#include "Button.hpp"
#include "GameX.hpp"

Button::Button(char* _buttonText, int _x1, int _y1, int _x2, int _y2)
{
	x1 = _x1;
	y1 = _y1;
	x2 = _x2;
	y2 = _y2;
	mousePressed = false;
	disabled = false;
	strcpy(buttonText, _buttonText);
	strLen = strlen(buttonText);
}

bool Button::Run()
{
	int mouseX = GameX.GetMouseX();
	int mouseY = GameX.GetMouseY();
	bool inBound = x1 < mouseX && mouseX < x2 && y1 < mouseY && mouseY < y2;
	bool clicked = false;

	if ( disabled )
		return false;

	if ( GameX.IsMouseDown(MOUSE_LEFT) )
	{
		if (inBound)
			mousePressed = true;
	}
	else
	{
		if (mousePressed)
			clicked = true;

		mousePressed = false;
	}
	
	return clicked;
}

void Button::Draw()
{
	GameX.DrawRect( ColorX(255,255,255), x1, y1, x2, y2);

	if (disabled)
		GameX.DrawRect( ColorX(152,152,166), x1+1, y1+1, x2-1, y2-1);
	else if (mousePressed)
    GameX.DrawRect( ColorX(185,223,251), x1+1, y1+1, x2-1, y2-1);
	else
		GameX.DrawRect( ColorX(40,155,242), x1+1, y1+1, x2-1, y2-1);

	GameX.DrawText( (x1+x2)/2 - 3.4*strLen, (y1+y2)/2-7, buttonText );
}
