
#ifndef GRAPH_HPP
#define GRAPH_HPP

#include <string>
using namespace std;

class Graph
{
private:
	float *ptBuffer;
	int *ptScreenBuffer;
	int numPoints;
	int startIndex;
	int nextIndex;
	int x1,y1,x2,y2,ymag,xmid,ymid;
	int drawDeltaX;
	float yaxisMin, yaxisMax, yaxisRange;
	float maxSeen, minSeen;
	bool showGraph, timeout; 
	char txt_title[20], txt_ymax[10], txt_ymin[10], txt_xmax[10], txt_minmaxSeen[40];
public:
	Graph(string _title, float _yaxisMin, float _yaxisMax, int _x1, int _y1, int _x2, int _y2);
	~Graph();
	void SetSize(int _x1, int _y1, int _x2, int _y2);
	void AddPoint(float pt);
	void ClearAll();
	void Draw();
	void Show() {showGraph = true;};
	void Hide() {showGraph = false;};
	void Toggle() {showGraph = !showGraph;};
	void SetShowGraph(bool _showGraph) {showGraph = _showGraph;};
};

#endif