
#include "LogFile.hpp"

LogFile::LogFile()
{
	writeEn = false;
	doneReadingLog = false;
	accLogFile = NULL;
}

bool LogFile::OpenForWriting(char* fileName)
{
	Close();
	accLogFile = fopen(fileName, "w+");

	if (accLogFile == NULL)
		return false;
	else
	{
		writeEn = true;
		return true;
	}
}

bool LogFile::OpenForReading(char* fileName)
{
	Close();
	accLogFile = fopen(fileName, "r");

	if (accLogFile == NULL)
		return false;
	else
	{
		doneReadingLog = false;
		return true;
	}
}

void LogFile::Close()
{
	doneReadingLog = false;
	if (accLogFile != NULL)
		fclose(accLogFile);
}

bool LogFile::Printf(LPCSTR lpszFormat, ...)
{
	if (accLogFile == NULL)
		return false;

	try
	{
		va_list args;
		va_start(args, lpszFormat);
		
		int nBuf;
		char szBuffer[8024];
		
		nBuf = _vsnprintf(szBuffer, sizeof(szBuffer), lpszFormat, args);
		
		assert(nBuf < sizeof(szBuffer));  //Output truncated as it was > sizeof(szBuffer)
		
		fprintf(accLogFile, szBuffer);

		va_end(args);
	}
	catch(...)
	{
		return false;
	}

	return true;
}

int LogFile::ReadLine(BYTE buffer[])
{
	int index = 0;
	char line[128];
	char* rv;

	if (doneReadingLog)
		return 0;

	if ( (rv = fgets(line, 128, accLogFile)) != NULL )
	{
		if (line[0] == '\n')
			doneReadingLog = true;
		else
		{
			line[strlen(line)-1] = '\0';

			int BytesRead, tempInt;
			char *nextByte, *tempLine = &line[0];

			for (index = 0; ; index++)
			{
				BytesRead = sscanf(tempLine, "%d", &tempInt);
				if (BytesRead == 1)
					buffer[index] = tempInt;
				else
					break;

				nextByte = strstr(tempLine, " ");
				if (nextByte == NULL)
					break;
				else
					tempLine = nextByte+1;
			}

			return index;
		}
	}
	else
		doneReadingLog = true;

	return 0;
}