
#ifndef __POINT_HPP__
#define __POINT_HPP__


#include "gamex.hpp"

#define ZERO_G		187
#define G_OFFSET	221
#define PI			3.14159f
#define OFFSET		Vector3DF( 748, 748, 748 )

class Point
{
protected:
	Vector3DF offset;					// offset values of accelerometer
	Vector3DF gravity;					// Gravity directional vector
	ImageX image;						// Image of a single "Dot"
	CameraX *cam;
	Point *parent;
	int dist;

	int prev_x;

	void ForceMove(void);
	void LPFilter( Vector3DF &a );
	void HPFilter( Vector3DF &v );
	float NormalizeAngle(float angle);

	float round( float a );


public:
	Point();
	Point(Vector3DF _pos, int _dist, Point *_parent, CameraX *_cam);
	void Run( Vector3DF t, CameraX *c );

	Vector3DF pos;
	Vector3DF vel;
	Vector3DF acc;

	float phi, theta, psi;

	void Draw();
	void Reset();
};



#endif